<?php
/**
 * Copyright 2019 aheadWorks. All rights reserved.
See LICENSE.txt for license details.
 */

namespace Aheadworks\Followupemail2\Model\ResourceModel\Campaign\Relation\Statistics;

use Aheadworks\Followupemail2\Api\StatisticsManagementInterface;
use Magento\Framework\EntityManager\Operation\ExtensionInterface;

/**
 * Class DeleteHandler
 * @package Aheadworks\Followupemail2\Model\ResourceModel\Campaign\Relation\Statistics
 * @codeCoverageIgnore
 */
class DeleteHandler implements ExtensionInterface
{
    /**
     * @var StatisticsManagementInterface
     */
    private $statisticsManagement;

    /**
     * @param StatisticsManagementInterface $statisticsManagement
     */
    public function __construct(
        StatisticsManagementInterface $statisticsManagement
    ) {
        $this->statisticsManagement = $statisticsManagement;
    }

    /**
     * {@inheritdoc}
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function execute($entity, $arguments = [])
    {
        $entityId = (int)$entity->getId();
        $this->statisticsManagement->updateByCampaignId($entityId);

        return $entity;
    }
}
